diff --git a/conf/type/__link/gencode b/conf/type/__link/gencode
new file mode 100755
index 00000000..4a97ac34
--- /dev/null
+++ b/conf/type/__link/gencode
@@ -0,0 +1,43 @@
+#!/bin/sh
+#
+# 2011 Nico Schottelius (nico-cdist at schottelius.org)
+#
+# This file is part of cdist.
+#
+# cdist is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# cdist is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with cdist. If not, see .
+#
+#
+# __file is a very basic type and should be able to be used as an
+# example for typewrites later
+#
+
+destination="/$__object_id"
+
+type="$(cat "$__object/parameter/type")"
+source="$(cat "$__object/parameter/source")"
+
+case "$type" in
+ symbolic)
+ lnopt="-s"
+ ;;
+ hard)
+ lnopt=""
+ ;;
+ *)
+ echo "Unknown type: $type" >&2
+ exit 1
+ ;;
+esac
+
+echo ln ${lnopts} -f \"$source\" \"$destination\"
diff --git a/conf/type/__link/man.text b/conf/type/__link/man.text
new file mode 100644
index 00000000..5022697a
--- /dev/null
+++ b/conf/type/__link/man.text
@@ -0,0 +1,57 @@
+cdist-type__link(7)
+===================
+Nico Schottelius
+
+
+NAME
+----
+cdist-type__link - Create links
+
+
+DESCRIPTION
+-----------
+This cdist type allows you to hard and symoblic links. The given
+object id is the destination for the link.
+
+
+REQUIRED PARAMETERS
+-------------------
+source::
+ Specifies the link source.
+
+source::
+ Specifies the link type: Either hard or symoblic.
+
+
+OPTIONAL PARAMETERS
+-------------------
+None.
+
+EXAMPLES
+--------
+
+--------------------------------------------------------------------------------
+# Create /etc/cdist-configured as an empty file
+__file /etc/cdist-configured --type file
+
+# Same but with a different object id
+__file cdist-marker --type file --destination /etc/cdist-configured
+
+# Use __file from another type
+__file /etc/issue --source "$__type/files/archlinux" --type file
+
+# Supply some more settings
+__file /etc/shadow --source "$__type/files/shadow" --type file \
+ --owner root --group shadow --mode 0640
+--------------------------------------------------------------------------------
+
+
+SEE ALSO
+--------
+- cdist-type(7)
+
+
+COPYING
+-------
+Copyright \(C) 2011 Nico Schottelius. Free use of this software is
+granted under the terms of the GNU General Public License version 3 (GPLv3).
diff --git a/conf/type/__link/parameter/optional b/conf/type/__link/parameter/optional
new file mode 100644
index 00000000..0c30f4be
--- /dev/null
+++ b/conf/type/__link/parameter/optional
@@ -0,0 +1,5 @@
+group
+mode
+owner
+source
+destination
diff --git a/conf/type/__link/parameter/required b/conf/type/__link/parameter/required
new file mode 100644
index 00000000..aa80e646
--- /dev/null
+++ b/conf/type/__link/parameter/required
@@ -0,0 +1 @@
+type